//
// PlansAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PlansAPI {
    /**
     Add cameras to plan

     - parameter body: (body)  
     - parameter planId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func addPlanCameras(body: PlanCamerasBody, planId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        addPlanCamerasWithRequestBuilder(body: body, planId: planId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Add cameras to plan
     - POST /api/v1/plans/{plan_id}/cameras

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter planId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func addPlanCamerasWithRequestBuilder(body: PlanCamerasBody, planId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/plans/{plan_id}/cameras"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Create new plan

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createPlan(body: PlanCreate, completion: @escaping ((_ data: PlanGet?,_ error: Error?) -> Void)) {
        createPlanWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new plan
     - POST /api/v1/plans
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "image_url" : "http://example.com/aeiou",
  "name" : "name",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "id" : 6,
  "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "place_id" : 0
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<PlanGet> 
     */
    open class func createPlanWithRequestBuilder(body: PlanCreate) -> RequestBuilder<PlanGet> {
        let path = "/api/v1/plans"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlanGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete specified plan

     - parameter planId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deletePlan(planId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deletePlanWithRequestBuilder(planId: planId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete specified plan
     - DELETE /api/v1/plans/{plan_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter planId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deletePlanWithRequestBuilder(planId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/plans/{plan_id}"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get plan with provided ID

     - parameter planId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlan(planId: Int, completion: @escaping ((_ data: PlanGet?,_ error: Error?) -> Void)) {
        getPlanWithRequestBuilder(planId: planId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get plan with provided ID
     - GET /api/v1/plans/{plan_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "image_url" : "http://example.com/aeiou",
  "name" : "name",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "id" : 6,
  "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "place_id" : 0
}}]
     - parameter planId: (path)  

     - returns: RequestBuilder<PlanGet> 
     */
    open class func getPlanWithRequestBuilder(planId: Int) -> RequestBuilder<PlanGet> {
        var path = "/api/v1/plans/{plan_id}"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlanGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get plan's cameras

     - parameter planId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlanCameras(planId: Int, completion: @escaping ((_ data: CameraPlanList?,_ error: Error?) -> Void)) {
        getPlanCamerasWithRequestBuilder(planId: planId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get plan's cameras
     - GET /api/v1/plans/{plan_id}/cameras
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "cameras" : [ {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "camera_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "x" : 0.23021358869347652,
    "y" : 0.7061401241503109,
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 5,
    "longitude" : 6.027456183070403
  }, {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "camera_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "x" : 0.23021358869347652,
    "y" : 0.7061401241503109,
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 5,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter planId: (path)  

     - returns: RequestBuilder<CameraPlanList> 
     */
    open class func getPlanCamerasWithRequestBuilder(planId: Int) -> RequestBuilder<CameraPlanList> {
        var path = "/api/v1/plans/{plan_id}/cameras"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<CameraPlanList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of plans

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlans(completion: @escaping ((_ data: PlanList?,_ error: Error?) -> Void)) {
        getPlansWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of plans
     - GET /api/v1/plans
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "plans" : [ {
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "image_url" : "http://example.com/aeiou",
    "name" : "name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : 6,
    "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 0
  }, {
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "image_url" : "http://example.com/aeiou",
    "name" : "name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : 6,
    "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 0
  } ]
}}]

     - returns: RequestBuilder<PlanList> 
     */
    open class func getPlansWithRequestBuilder() -> RequestBuilder<PlanList> {
        let path = "/api/v1/plans"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlanList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Remove cameras from the plan

     - parameter body: (body)  
     - parameter planId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func removePlanCameras(body: PlanCamerasBody, planId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        removePlanCamerasWithRequestBuilder(body: body, planId: planId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Remove cameras from the plan
     - DELETE /api/v1/plans/{plan_id}/cameras

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter planId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func removePlanCamerasWithRequestBuilder(body: PlanCamerasBody, planId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/plans/{plan_id}/cameras"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Search plans by provided query string

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchPlans(body: PlanSearchBody, completion: @escaping ((_ data: PlanList?,_ error: Error?) -> Void)) {
        searchPlansWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search plans by provided query string
     - POST /api/v1/plans/search

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "plans" : [ {
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "image_url" : "http://example.com/aeiou",
    "name" : "name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : 6,
    "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 0
  }, {
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "image_url" : "http://example.com/aeiou",
    "name" : "name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : 6,
    "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 0
  } ]
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<PlanList> 
     */
    open class func searchPlansWithRequestBuilder(body: PlanSearchBody) -> RequestBuilder<PlanList> {
        let path = "/api/v1/plans/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlanList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera position on the plan

     - parameter body: (body)  
     - parameter planId: (path)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraPosition(body: CameraPlan, planId: Int, cameraId: UUID, completion: @escaping ((_ data: CameraPlanInternal?,_ error: Error?) -> Void)) {
        updateCameraPositionWithRequestBuilder(body: body, planId: planId, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera position on the plan
     - PUT /api/v1/plans/{plan_id}/cameras/{camera_id}/position

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "x" : 0.08008281904610115,
  "camera_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "y" : 0.6027456183070403,
  "plan_id" : 1
}}]
     - parameter body: (body)  
     - parameter planId: (path)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<CameraPlanInternal> 
     */
    open class func updateCameraPositionWithRequestBuilder(body: CameraPlan, planId: Int, cameraId: UUID) -> RequestBuilder<CameraPlanInternal> {
        var path = "/api/v1/plans/{plan_id}/cameras/{camera_id}/position"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<CameraPlanInternal>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update plan with provided ID

     - parameter body: (body)  
     - parameter planId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updatePlan(body: PlanUpdate, planId: Int, completion: @escaping ((_ data: PlanGet?,_ error: Error?) -> Void)) {
        updatePlanWithRequestBuilder(body: body, planId: planId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update plan with provided ID
     - PUT /api/v1/plans/{plan_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "image_url" : "http://example.com/aeiou",
  "name" : "name",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "id" : 6,
  "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "place_id" : 0
}}]
     - parameter body: (body)  
     - parameter planId: (path)  

     - returns: RequestBuilder<PlanGet> 
     */
    open class func updatePlanWithRequestBuilder(body: PlanUpdate, planId: Int) -> RequestBuilder<PlanGet> {
        var path = "/api/v1/plans/{plan_id}"
        let planIdPreEscape = "\(planId)"
        let planIdPostEscape = planIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plan_id}", with: planIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlanGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
